    [WebMethod]
    public byte[] MaterializeMapPDFPage(string session, string mapname, int width, int height, string imageflavor)
    {
        if (this._site == null)
        {
            this.SetUp(session, mapname);
        }
        Document document = null;
        ByteArrayOutputStream baos = null;
        PdfWriter writer = null;
        byte[] theOutputPDF = null;

        byte[] forPdf1 = MaterializeMapImagePage(session, mapname, width, height, imageflavor);
        byte[] forPdf2 = MaterializeMapImagePage(session, mapname,
            System.Convert.ToInt32(Math.Ceiling(width * .65)),
            System.Convert.ToInt32(Math.Ceiling(height * .65)), imageflavor);
        byte[] forPdf3 = MaterializeMapImagePage(session, mapname,
            System.Convert.ToInt32(Math.Ceiling(width * .40)),
            System.Convert.ToInt32(Math.Ceiling(height * .40)), imageflavor);
        try
        {
            com.lowagie.text.Image img1 = com.lowagie.text.Image.getInstance(forPdf1);
            com.lowagie.text.Image img2 = com.lowagie.text.Image.getInstance(forPdf2);
            com.lowagie.text.Image img3 = com.lowagie.text.Image.getInstance(forPdf3);
            document = new Document();
            baos = new ByteArrayOutputStream();
            writer = PdfWriter.getInstance(document, baos);
            writer.setViewerPreferences(PdfWriter.PageModeUseThumbs | PdfWriter.PageLayoutSinglePage | PdfWriter.FitWindow);
            PdfPageLabels pageLabels = new PdfPageLabels();
            int dpiX;
            int dpiY;
            float imgWidthPica;
            float imgHeightPica;
            //
            //img1
            // 
            dpiX = img1.getDpiX();
            if (dpiX == 0) dpiX = 72;
            dpiY = img1.getDpiY();
            if (dpiY == 0) dpiY = 72;
            imgWidthPica = (72 * img1.getPlainWidth()) / dpiX;
            imgHeightPica = (72 * img1.getPlainHeight()) / dpiY;
            img1.scaleAbsolute(imgWidthPica, imgHeightPica);
            document.setPageSize(new Rectangle(imgWidthPica, imgHeightPica));
            if (document.isOpen())
            {
                document.newPage();
            }
            else
            {
                document.open();
            }
            img1.setAbsolutePosition(0, 0);
            document.add(img1);
            pageLabels.addPageLabel(writer.getPageNumber(), PdfPageLabels.UPPERCASE_LETTERS);
            //
            //img2
            // 
            dpiX = img2.getDpiX();
            if (dpiX == 0) dpiX = 72;
            dpiY = img2.getDpiY();
            if (dpiY == 0) dpiY = 72;
            imgWidthPica = (72 * img2.getPlainWidth()) / dpiX;
            imgHeightPica = (72 * img2.getPlainHeight()) / dpiY;
            img2.scaleAbsolute(imgWidthPica, imgHeightPica);
            document.setPageSize(new Rectangle(imgWidthPica, imgHeightPica));
            if (document.isOpen())
            {
                document.newPage();
            }
            else
            {
                document.open();
            }
            img2.setAbsolutePosition(0, 0);
            document.add(img2);
            pageLabels.addPageLabel(writer.getPageNumber(), PdfPageLabels.UPPERCASE_LETTERS);
            //
            //img3
            // 
            dpiX = img3.getDpiX();
            if (dpiX == 0) dpiX = 72;
            dpiY = img3.getDpiY();
            if (dpiY == 0) dpiY = 72;
            imgWidthPica = (72 * img3.getPlainWidth()) / dpiX;
            imgHeightPica = (72 * img3.getPlainHeight()) / dpiY;
            img3.scaleAbsolute(imgWidthPica, imgHeightPica);
            document.setPageSize(new Rectangle(imgWidthPica, imgHeightPica));
            if (document.isOpen())
            {
                document.newPage();
            }
            else
            {
                document.open();
            }
            img3.setAbsolutePosition(0, 0);
            document.add(img3);
            pageLabels.addPageLabel(writer.getPageNumber(), PdfPageLabels.UPPERCASE_LETTERS);
        }
        catch (System.Exception)
        {
            StringBuilder sb = new StringBuilder();
            sb.Append(" ***** Error with Map Image --> ");
            sb.Append("Session: " + session + "    Map: " + mapname);
            sb.Append(" ***** Contact Application Maintenance Personnel.");
            document.add(new Paragraph(sb.ToString()));
        }

        string stuff = SelectAllScribbleFeatures(session, mapname);
        if (stuff != null)
        {
            document.newPage();
            document.add(new Paragraph("MarkUps for " + System.DateTime.Now.ToString() + "\r\n\r\n" + stuff));
        }

        // step 5: we close the document
        if (document != null)
            document.close();

        theOutputPDF = baos.toByteArray();

        return theOutputPDF;
    }
	    [WebMethod]
    public string SelectAllScribbleFeatures(string session, string mapname)
    {
        if (this._site == null)
        {
            this.SetUp(session, mapname);
        }
        StringBuilder sb = new StringBuilder();
        MgResourceService resourceService = (MgResourceService)_site.CreateService(MgServiceType.ResourceService);
        MgMap map = new MgMap();
        map.Open(resourceService, this._mapname);
        MgCoordinateSystemFactory coordSysFactory = new MgCoordinateSystemFactory();
        MgCoordinateSystem target = coordSysFactory.Create(map.GetMapSRS());
        MgCoordinateSystem source = coordSysFactory.Create(FL83_EF);
        MgCoordinateSystemTransform coorXform = coordSysFactory.GetTransform(source, target);

        MgFeatureService featureService = (MgFeatureService)_site.CreateService(MgServiceType.FeatureService);
        MgResourceIdentifier featureSourceId = new MgResourceIdentifier(_Session_StringBuilder.ToString() + _layerName + ".FeatureSource");
        MgFeatureQueryOptions qOpts = new MgFeatureQueryOptions();
        qOpts.SetFilter(_IDpropertyName + " >= 0");
        MgFeatureReader fr = featureService.SelectFeatures(featureSourceId, _className, qOpts);
        MgAgfReaderWriter geometryReaderWriter = new MgAgfReaderWriter();
        while (fr.ReadNext())
        {
            int id = fr.GetInt32(_IDpropertyName);
            string text = fr.GetString(_TEXTpropertyName);
            MgByteReader byteReader = fr.GetGeometry(_GEOMETRYpropertyName);
            MgGeometry geometry = geometryReaderWriter.Read(byteReader);
            MgGeometricEntity ge = geometry.Transform(coorXform);
            MgPoint center = ge.Centroid;
            sb.Append(id.ToString());
            sb.Append(" ~ ");
            sb.Append(center.Coordinate.GetX().ToString() + " " + center.Coordinate.GetY().ToString());
            sb.Append(" ~ ");
            sb.Append(text);
            sb.Append("\r\n");
            sb.Append("\r\n");
        }
        fr.Close();
        return sb.ToString();
    }