﻿<%@ Page Language="C#" ValidateRequest="false" AutoEventWireup="true" CodeFile="scribble.aspx.cs" Inherits="scribble" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Scribble_WM Page</title>
    <link rel="stylesheet" href="styles/gt.css" type="text/css">
    <link href="styles/ajaxtools.css" rel="stylesheet" type="text/css" />
    <script language="javascript" src="../viewerfiles/browserdetect.js"></script>
	<script language="javascript">
		
		var CMD_MATERIALIIZE	= <%= ScribbleCommand.MaterializeScribble %>;
		var CMD_ADD_POINT		= <%= ScribbleCommand.AddPoint %>;
		var CMD_ADD_LINE 		= <%= ScribbleCommand.AddLine %>;
		var CMD_ADD_LINESTRING 	= <%= ScribbleCommand.AddLineString %>;
		var CMD_ADD_RECTANGLE 	= <%= ScribbleCommand.AddRectangle %>;
		var CMD_ADD_POLYGON 	= <%= ScribbleCommand.AddPolygon %>;
		var CMD_DELETEALL 		= <%= ScribbleCommand.DeleteAll %>;
		var CMD_DELETESELECTED	= <%= ScribbleCommand.DeleteSelected %>;
		var CMD_UPDATE 			= <%= ScribbleCommand.Update %>;
		var CMD_ADD_CIRCLE 		= <%= ScribbleCommand.AddCircle %>;
		var CMD_PRINTIT 		= <%= ScribbleCommand.PrintIt %>;
		var CMD_SELECTFEATURE	= <%= ScribbleCommand.SelectFeature %>;
		var CMD_EXTRACTGEOMETRY	= <%= ScribbleCommand.ExtractGeometryFromSelection %>;
		var CMD_DBUPDATEVIEW	= <%= ScribbleCommand.DBUpdateView %>;
		var CMD_DBUPDATECAMERA	= <%= ScribbleCommand.DBUpdateCamera %>;
		var CMD_WRITESCRIBBLEFROMDB = <%= ScribbleCommand.WriteScribbleFromDB %>;
		var CMD_DEMATERIALIIZE	= <%= ScribbleCommand.DeMaterializeScribble %>;
		
	    var INFO_BLANK = " ";
	    var INFO_NOTHINGTODELETE = "*No selection has been made to delete.";
	    var INFO_NOTHINGTOUPDATE = "*No selection has been made to update text on.";
	    var INFO_MAKESELECTION = "*You must make a selection to produce output.";

	    var EDIT_DEFAULT_HELP = "To begin select the type of markup to digitize.";
		var EDIT_POINT_HELP = "Click the map to specify the location of the point.";
		var EDIT_LINE_HELP = "Click and drag on the map to specify the start and end points of the line.";
		var EDIT_LINESTRING_HELP = "Click the map to define each point of the line, Ctrl-Click on the final point to end.";
		var EDIT_RECTANGLE_HELP = "Click on the map to specify the first corner and drag the mouse to define the rectangle.";
		var EDIT_POLYGON_HELP = "Click the map to define each point of the polygon, Ctrl-Click on the final point to end.";
		var EDIT_CIRCLE_HELP = "Click and drag on the map to specify the start point and radius of the circle.";
        var SCRIBBLEPDF_WIDTH = 1024;
        var SCRIBBLEPDF_HEIGHT = 1280;
        var SCRIBBLEPDF_TYPE = "PNG";       
        //
        // Set a timer to loop until the other frames are instantiated.
        //
	    var originalOnSelectionChanged;	    
		var initTimer = setInterval(watchForInitializationComplete, 250); 
        function watchForInitializationComplete()
        { 
            try { 
                if(parent.parent.parent.mapFrame.GetMapName) 
                { 
			        //alert("within watchForInitialization ...");
                    var mapName = parent.parent.parent.mapFrame.GetMapName();                   
                    if ( mapName != null) {
                        var mapNameControl = document.getElementById("mapName");
                        mapNameControl.value = mapName;
                        var legend_done = false;
                        if (parent.parent.parent.mapFrame.GetLegendCtrl)
                        {
                            legend_done = parent.parent.parent.mapFrame.GetLegendCtrl().InternalStateComplete();
                            if (legend_done == true)
                            {
                               clearInterval(initTimer);
                               originalOnSelectionChanged = parent.parent.parent.OnSelectionChanged;
                               parent.parent.parent.OnSelectionChanged = LocalOnSelectionChangedHandler;
                               //alert(originalOnSelectionChanged);
                               tmp_control = document.getElementById("sessionName");
		                       SESSION = tmp_control.value;
                               ScribbleMethodsMgr.MaterializeScribble(SESSION, mapName
                                                                        ,OnCompleteScribbleMethods,OnError_Generic,OnTimeOut_Generic);
                            }
                        } 
                    }
                } 
            } 
            catch(Exception) { } 
            //catch(Exception) { alert("Waiting: Map has not finished building. click and Retry."); } 
        }
        function OnCompleteScribbleMethods(arg) { SetDigitizeInfo(INFO_BLANK); parent.parent.parent.mapFrame.Refresh(); }
        function OnTimeOut_Generic(arg) { alert("TimeOut encountered within application."); }
        function OnError_Generic(arg) { alert("Error encountered within application."); }
	    
  	    function LocalOnSelectionChangedHandler() {
            originalOnSelectionChanged ();
            var mapFrame = parent.parent.parent.GetMapFrame();
            selCount = mapFrame.GetSelectedCount();
            currentscribbleselectionXMLcntrl = document.getElementById("currentscribbleselectionXML");
			currentscribbleselectionXMLcntrl.value = parent.parent.parent.mapFrame.GetSelectionXML();
        }	    
       
		function SetDigitizeInfo(text)
		{
			var digitizeInfo = document.getElementById("digitizeInfo");
			digitizeInfo.innerHTML = text;
		}
		function PromptAndSetScribbleText()
		{
			var textInput = document.getElementById("currentscribbleText");
			textLabel = window.prompt("Enter label/text for the markup item", "");
			textInput.value = (textLabel != null) ? textLabel : "";
		}
		function AddPoint()
		{
			SetDigitizeInfo(EDIT_POINT_HELP);
			parent.parent.parent.mapFrame.DigitizePoint(OnPointDigitized);
		}

		function AddLine()
		{
			SetDigitizeInfo(EDIT_LINE_HELP);
			parent.parent.parent.mapFrame.DigitizeLine(OnLineStringDigitized);
		}

		function AddLineString()
		{
			SetDigitizeInfo(EDIT_LINESTRING_HELP);
			parent.parent.parent.mapFrame.DigitizeLineString(OnLineStringDigitized);
		}

		function AddRectangle()
		{
			SetDigitizeInfo(EDIT_RECTANGLE_HELP);
			parent.parent.parent.mapFrame.DigitizeRectangle(OnRectangleDigitized);
		}

		function AddPolygon()
		{
			SetDigitizeInfo(EDIT_POLYGON_HELP);
			parent.parent.parent.mapFrame.DigitizePolygon(OnPolyonDigitized);
		}

		function AddCircle()
		{
			SetDigitizeInfo(EDIT_CIRCLE_HELP);
			parent.parent.parent.mapFrame.DigitizeCircle(OnCircleDigitized);
		}
	
		function OnPointDigitized(point)
		{
		    PromptAndSetScribbleText();
		    
		    geometryInput = document.getElementById("currentscribblegeometryInput");
			geometryInput.value = point.X + "," + point.Y;
			tmp_control = document.getElementById("sessionName");
			SESSION = tmp_control.value;
			tmp_control = document.getElementById("mapName");
			MAPNAME = tmp_control.value;
			tmp_control = document.getElementById("currentscribbleText");
			TEXT = tmp_control.value;
			
			ScribbleMethodsMgr.MaterializeScribbleFeature(SESSION, MAPNAME, CMD_ADD_POINT, TEXT, geometryInput.value
			                                        ,OnCompleteScribbleMethods, OnError_Generic, OnTimeOut_Generic);
		}

		function OnLineStringDigitized(lineString)
		{
			PromptAndSetScribbleText();
			
			var geomText = lineString.Count;
			for (var i = 0; i < lineString.Count; i++)
			{
				geomText += "," + lineString.Point(i).X + "," + lineString.Point(i).Y;
			}		
			var geometryInput = document.getElementById("currentscribblegeometryInput");
			geometryInput.value = geomText;
			tmp_control = document.getElementById("sessionName");
			SESSION = tmp_control.value;
			tmp_control = document.getElementById("mapName");
			MAPNAME = tmp_control.value;
			tmp_control = document.getElementById("currentscribbleText");
			TEXT = tmp_control.value;
			
			ScribbleMethodsMgr.MaterializeScribbleFeature(SESSION, MAPNAME, CMD_ADD_LINESTRING, TEXT, geometryInput.value
			                                                ,OnCompleteScribbleMethods, OnError_Generic, OnTimeOut_Generic);
		}

		function OnRectangleDigitized(rectangle)
		{
			PromptAndSetScribbleText();
			
			var geometryInput = document.getElementById("currentscribblegeometryInput");
			geometryInput.value = "5," 
				+ rectangle.Point1.X + "," + rectangle.Point1.Y + ","
				+ rectangle.Point2.X + "," + rectangle.Point1.Y + ","
				+ rectangle.Point2.X + "," + rectangle.Point2.Y + ","
				+ rectangle.Point1.X + "," + rectangle.Point2.Y + ","
				+ rectangle.Point1.X + "," + rectangle.Point1.Y;   
			tmp_control = document.getElementById("sessionName");
			SESSION = tmp_control.value;
			tmp_control = document.getElementById("mapName");
			MAPNAME = tmp_control.value;
			tmp_control = document.getElementById("currentscribbleText");
			TEXT = tmp_control.value;

			ScribbleMethodsMgr.MaterializeScribbleFeature(SESSION, MAPNAME, CMD_ADD_RECTANGLE, TEXT, geometryInput.value
			                                                ,OnCompleteScribbleMethods, OnError_Generic, OnTimeOut_Generic);
		}
	
		function OnPolyonDigitized(polygon)
		{
			PromptAndSetScribbleText();
			
			var geomText = polygon.Count;
			for (var i = 0; i < polygon.Count; i++)
			{
				geomText += "," + polygon.Point(i).X + "," + polygon.Point(i).Y;
			}		
			var geometryInput = document.getElementById("currentscribblegeometryInput");
			geometryInput.value = geomText;
			tmp_control = document.getElementById("sessionName");
			SESSION = tmp_control.value;
			tmp_control = document.getElementById("mapName");
			MAPNAME = tmp_control.value;
			tmp_control = document.getElementById("currentscribbleText");
			TEXT = tmp_control.value;
			
			ScribbleMethodsMgr.MaterializeScribbleFeature(SESSION, MAPNAME, CMD_ADD_POLYGON, TEXT, geometryInput.value
			                                                ,OnCompleteScribbleMethods, OnError_Generic, OnTimeOut_Generic);
		}

		function OnCircleDigitized(Circle)
		{
			PromptAndSetScribbleText();
			
			var geomText = Circle.Radius;
    		geomText += "," + Circle.Center.X + "," + Circle.Center.Y;
			var geometryInput = document.getElementById("currentscribblegeometryInput");
			geometryInput.value = geomText;
			tmp_control = document.getElementById("sessionName");
			SESSION = tmp_control.value;
			tmp_control = document.getElementById("mapName");
			MAPNAME = tmp_control.value;
			tmp_control = document.getElementById("currentscribbleText");
			TEXT = tmp_control.value;
			
			ScribbleMethodsMgr.MaterializeScribbleFeature(SESSION, MAPNAME, CMD_ADD_CIRCLE, TEXT, geometryInput.value
			                                                ,OnCompleteScribbleMethods, OnError_Generic, OnTimeOut_Generic);
		}
			
		function DeleteAll()
		{            
			tmp_control = document.getElementById("sessionName");
			SESSION = tmp_control.value;
			tmp_control = document.getElementById("mapName");
			MAPNAME = tmp_control.value;
			ScribbleMethodsMgr.DeleteScribbleFeatures(SESSION, MAPNAME
			                                            ,OnCompleteScribbleMethods, OnError_Generic, OnTimeOut_Generic);			                                            
		}
		
		function DeleteSelected()
		{            
			var mapFrame = parent.parent.parent.GetMapFrame();
            selCount = mapFrame.GetSelectedCount();
			if ( selCount > 0 )
			{
			    tmp_control = document.getElementById("currentscribbleselectionXML");
			    SELECTION = tmp_control.value;
			    tmp_control = document.getElementById("sessionName");
			    SESSION = tmp_control.value;
			    tmp_control = document.getElementById("mapName");
			    MAPNAME = tmp_control.value;
			    ScribbleMethodsMgr.DeleteScribbleSelectedFeatures(SESSION, MAPNAME, SELECTION
			                                                        ,OnCompleteScribbleMethods, OnError_Generic, OnTimeOut_Generic);
			} else {
			    SetDigitizeInfo(INFO_NOTHINGTODELETE);
			}
		}

		function UpdateSelectedText()
		{ 
		 	var mapFrame = parent.parent.parent.GetMapFrame();
            selCount = mapFrame.GetSelectedCount();
			if ( selCount > 0 )
			{
			    PromptAndSetScribbleText();
			    
			    tmp_control = document.getElementById("currentscribbleText");
			    TEXT = tmp_control.value;
			    tmp_control = document.getElementById("currentscribbleselectionXML");
			    SELECTION = tmp_control.value;
			    tmp_control = document.getElementById("sessionName");
			    SESSION = tmp_control.value;
			    tmp_control = document.getElementById("mapName");
			    MAPNAME = tmp_control.value;
			    ScribbleMethodsMgr.UpdateScribbleText(SESSION, MAPNAME, SELECTION, TEXT
			                                                        ,OnCompleteScribbleMethods, OnError_Generic, OnTimeOut_Generic);
			} else {
			    SetDigitizeInfo(INFO_NOTHINGTOUPDATE);
			}
          
        }

		function ScribblePDF()
		{
		    tmp_control = document.getElementById("sessionName");
		    SESSION = tmp_control.value;
		    tmp_control = document.getElementById("mapName");
		    MAPNAME = tmp_control.value;
            w = window.open("scribblepdfdoc.ashx?SESSION=" + SESSION + "&MAPNAME=" +MAPNAME + "&WIDTH=" + SCRIBBLEPDF_WIDTH + "&HEIGHT=" +SCRIBBLEPDF_HEIGHT + "&TYPE=" +SCRIBBLEPDF_TYPE ,"pdfmap","toolbar=no,status=no,width=550,height=720,resizable=yes,scrollbars=yes",false);
            try {
                w.focus();
            } catch(Exception) { }   
		}

		function ScribbleTXT()
		{
		    if (GetSelectionXML())
		    {
		        tmp_control = document.getElementById("sessionName");
		        SESSION = tmp_control.value;
		        tmp_control = document.getElementById("mapName");
		        MAPNAME = tmp_control.value;
		        tmp_control = document.getElementById("currentscribbleselectionXML");
		        SELECTION = tmp_control.value;
                w = window.open("scribbletxtdoc.ashx?SESSION=" + SESSION + "&MAPNAME=" +MAPNAME + "&SELECTION=" + SELECTION,"txtmap","toolbar=no,status=no,width=550,height=720,resizable=yes,scrollbars=yes",false);
                try {
                    w.focus();
                } catch(Exception) { }   
            }
		}
		
	    function GetSelectionXML()
		{            
			var HasSelection = false;
			currentselectionXML = document.getElementById("currentscribbleselectionXML");
			currentselectionXML.value = "";
			var selectionXML = parent.parent.parent.mapFrame.GetSelectionXML();
			if (selectionXML == ""){
			    alert("Error: You must select one(1) geometry object on the map; then retry.");
			    return false;
			} else {
			    currentselectionXML.value = selectionXML;		
			    return true;
			}
		}
		function OnLoad()
		{
	        var refreshMapNow = "<%= refreshMap %>";
            if (refreshMapNow == "True")
			    parent.parent.parent.Refresh();
					
			SetDigitizeInfo(EDIT_DEFAULT_HELP);
		}

	</script>	
</head>

<body onload='OnLoad()'>
    <form id="form1" runat="server">
     
        <ajaxToolkit:ToolkitScriptManager ID="TKScriptManager" runat="server" >
            <Services>
                <asp:ServiceReference Path="scribblemethodsmgr.asmx" />
              </Services>
         </ajaxToolkit:ToolkitScriptManager>
          
			
			<table class="RegText" border="0" cellspacing="0" width="100%">
                <tr>
                    <td colspan="2" class="Title">
                        Add or Delete Geometry
                        <hr>
                    </td>
                </tr>
                <tr>
                    <td colspan="2" class="SubTitle">
                        Add Geometry</td>
                </tr>
                <tr>
                    <td colspan="2">
                        Digitize Geometry:</td>
                </tr>
                <tr>
                    <td colspan="2" height="2">
                    </td>
                </tr>
                <tr>
                    <td colspan="2" align="center">
                        <input class="Ctrl" id="pointBtn" type="button" onclick="AddPoint()" value="Point"
                            style="width: 60px">
                        <input class="Ctrl" id="lineBtn" type="button" onclick="AddLine()" value="Line" style="width: 60px">
                        <input class="Ctrl" id="lineStringBtn" type="button" onclick="AddLineString()" value="Line String"
                            style="width: 60px">
                    </td>
                </tr>
                <tr>
                    <td colspan="2" align="center" >
                        <input class="Ctrl" id="rectangleBtn" type="button" onclick="AddRectangle()" value="Rectangle"
                            style="width: 60px">
                        <input class="Ctrl" id="polygonBtn" type="button" onclick="AddPolygon()" value="Polygon"
                            style="width: 60px">
                        <input class="Ctrl" id="circleBtn" type="button" onclick="AddCircle()" value="Circle"
                            style="width: 60px">
                    </td>
                </tr>
                <tr>
                    <td colspan="2" height="2">
                    </td>
                </tr>
                <tr>
                    <td class="InfoText" colspan="2" id="digitizeInfo" style="height: 16px">
                    </td>
                </tr>
                <tr>
                    <td colspan="2">
                    </td>
                </tr>
                
                 <tr>
                    <td colspan="2" class="SubTitle">
                        Delete Geometry</td>
                </tr>
                
                <tr>
                    <td colspan="2" height="2">
                     Digitized Geometry:</td>
                </tr>
                <tr>
                    <td colspan="2" align="center" >
                
                        <input class="Ctrl" id="deleteBtn2" type="button" onclick="DeleteSelected()" value="Delete Selected"  style="width: 80px">
                        <input class="Ctrl" id="deleteBtn1" type="button" onclick="DeleteAll()" value="Delete All"  style="width: 80px">
        
                        <hr>
                    </td>
                </tr>
               
               
                <tr>
                    <td colspan="2" class="SubTitle">
                        Modify Text</td>
                </tr>
                
                <tr>
                    <td colspan="2" height="2">
                     Update Text of Current Selection:</td>
                </tr>
                <tr>
                    <td colspan="2" align="center" >               
                        <input class="Ctrl" id="modtextBtn" type="button" onclick="UpdateSelectedText()" value="Modify Text"  style="width: 80px">
                        <hr>
                    </td>
                </tr>
               
                           
                <tr>
                    <td colspan="2" class="SubTitle">
                        Simple Map Output</td>
                </tr>
                
                <tr>
                    <td colspan="2" height="2">
                     Output Current Map:</td>
                </tr>
                <tr>
                    <td colspan="2" align="center" >               
                        <input class="Ctrl" id="pdfBtn" type="button" onclick="ScribblePDF()" value="PDF Document"  style="width: 80px">
                        <input class="Ctrl" id="txtBtn" type="button" onclick="ScribbleTXT()" value="Selected Items to Text Table"  style="width: 160px">
                        <hr>
                    </td>
                </tr>

               
               
            </table>              
            
        <asp:HiddenField ID="sessionName" runat="server" />
        <asp:HiddenField ID="mapName" runat="server" />
        <asp:HiddenField ID="appl_physical_path" runat="server" />
        <asp:HiddenField ID="currentscribbleCommand" runat="server" />
        <asp:HiddenField ID="currentscribbleFeature" runat="server" />
        <asp:HiddenField ID="currentscribbleText" runat="server" />
        <asp:HiddenField ID="currentscribbleselectionXML" runat="server" />
        <asp:HiddenField ID="currentscribblegeometryInput" runat="server" />
    </form>
</body>
</html>
